#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <string.h>
#include <sys/types.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <pwd.h>
#include "crypt.h"
#ifdef HAVE_SHADOW_H
#include <shadow.h>
#endif
#ifdef TIME_WITH_SYS_TIME
#  include <sys/time.h>
#  include <time.h>
#else
#  ifdef HAVE_SYS_TIME_H
#    include <sys/time.h>
#  else
#    include <time.h>
#  endif
#endif

#include "extern.h"


/* If name is "ftp" or "anonymous", the name is not in
   PATH_FTPUSERS, and ftp account exists, set cred, then just return.
   If account doesn't exist, ask for passwd anyway.  Otherwise, check user
   requesting login privileges.  Disallow anyone who does not have a standard
   shell as returned by getusershell().  Disallow anyone mentioned in the file
   PATH_FTPUSERS to allow people such as root and uucp to be avoided.  */

int
auth_user (const char *name, struct credentials *pcred)
{
  size_t len;

  pcred->guest = 0;

  if (pcred->message)
    free (pcred->message);
  len = 64 + strlen (name);
  pcred->message = malloc (len);

  if (pcred->message == NULL)
    return -1;

  /* check for anonymous logging */
  if (strcmp (name, "ftp") == 0
      || strcmp (name, "anonymous") == 0)
    {
      pcred->guest = 1;
      strcpy (pcred->message,
		  "Guest login ok, type your name as password.");
      return 0;
    }
  else
    {
      snprintf (pcred->message, len, "User %s unknown.", name);
      return 1;
    }
}

int
auth_pass (const char *passwd, struct credentials *pcred)
{
  return 0;
}
